/*/////////////////////////////////////////////////////////
Programme : Mini-station météo sur Serveur Node-Red
Date : 27/02/2023
Nom du programmeur : PIERRON Benoit
Lycée : Jean Jaurès, 12400 Saint Affrique
/////////////////////////////////////////////////////////*/

void setup()//Création de la fonction d'initialisation
{
Serial.begin(115200);//Initialisation de la liaison UART (moniteur série) avec un débit de 115200 bauds
}

void loop()//Création de la fonction principale                                QUESTION 5
{
int a0 = analogRead(A0);/*Création de la variable (nombre entier) a0 qui va contenir la valeur du nombre
numérique compris entre 0 et 1023 qui est l'image de la tension analogique de la broche A0*/
float voltage = (a0 / 1023.0) * 5.0;/*Création de la variable voltage (nombre décimal) qui calcul 
la valeur de la tension analogique de la broche A0 en mutipliant par le quantum du CAN*/
float temp = (voltage - .5) * 100;/*Création de la variable temp (nombre décimal) qui calcul la valeur
de la température issue du capteur TMP36. On enlève 0.5 V pour l'Offset du capteur (500mV pour 0 degré)
et on multiplie par 100 car le capteur donne 10 mV par degré.*/                                  
int a1 = analogRead(A1);/*Création de la variable (nombre entier) a1 qui va contenir la valeur du nombre
numérique compris entre 0 et 1023 qui est l'image de la tension analogique de la broche A1*/
float eclair = (a1*0.7);/*Création de la variable eclair (nombre décimal) qui calcul la valeur de la  
température issue du capteur LDR. On multiplie par 0.7 pour simplifier la mise à l'échelle qui n'est pas
linéaire. Cela fonctionne pour des éclairement autour de 500 Lux. Avec un Luxmètre, le nombre numérique 
est environ de 700 pour 500 Lux.*/
//                                                                             QUESTION 6

Serial.print("{\"TMP36\":");/*On écrit dans le moniteur série {"TMP36":  On écrit \" pour ne par fermer 
avec les guillemets mais dire au compilateur qu'on veut écrire une guillemet, on échappe avec : \    */                       
Serial.print(temp);//On écrit dans le moniteur série la valeur de la variable temp
Serial.print(",\"LDR\":"); //On écrit dans le moniteur série ,"LDR":     
Serial.print(eclair);//On écrit dans le moniteur série la valeur de la variable eclair
Serial.println("}");//On écrit dans le moniteur série }
delay(5000);//Pause de 5 secondes pour stabliser l'affichage des valeurs sur la dashboard côté client
}
